Add ODL netvirt VPP support
[apex.git] / lib / overcloud-deploy-functions.sh
1 #!/usr/bin/env bash
2 ##############################################################################
3 # Copyright (c) 2015 Tim Rozet (Red Hat), Dan Radez (Red Hat) and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 ##preping it for deployment and launch the deploy
12 ##params: none
13 function overcloud_deploy {
14   local num_compute_nodes
15   local num_control_nodes
16   local dpdk_cores pmd_cores socket_mem ovs_dpdk_perf_flag ovs_option_heat_arr
17   declare -A ovs_option_heat_arr
18
19   ovs_option_heat_arr['dpdk_cores']=OvsDpdkCoreList
20   ovs_option_heat_arr['pmd_cores']=PmdCoreList
21   ovs_option_heat_arr['socket_memory']=OvsDpdkSocketMemory
22
23   # OPNFV Default Environment and Network settings
24   DEPLOY_OPTIONS+=" -e ${ENV_FILE}"
25   DEPLOY_OPTIONS+=" -e network-environment.yaml"
26
27   # Custom Deploy Environment Templates
28   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
29     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
30       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sfc.yaml"
31     elif [ "${deploy_options_array['vpn']}" == 'True' ]; then
32       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-bgpvpn.yaml"
33       if [ "${deploy_options_array['gluon']}" == 'True' ]; then
34         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/services/gluon.yaml"
35       fi
36     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
37       if [ "${deploy_options_array['odl_vpp_netvirt']}" == "True" ]; then
38         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-netvirt-vpp.yaml"
39       elif [ "${deploy_options_array['sdn_l3']}" == "True" ]; then
40         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb.yaml"
41       else
42         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb-l2.yaml"
43       fi
44     else
45       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-l3.yaml"
46     fi
47     SDN_IMAGE=opendaylight
48   elif [ "${deploy_options_array['sdn_controller']}" == 'opendaylight-external' ]; then
49     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
50     SDN_IMAGE=opendaylight
51   elif [ "${deploy_options_array['sdn_controller']}" == 'onos' ]; then
52     echo -e "${red}ERROR: ONOS is unsupported in Danube...exiting${reset}"
53     exit 1
54     #if [ "${deploy_options_array['sfc']}" == 'True' ]; then
55     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos_sfc.yaml"
56     #else
57     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos.yaml"
58     #fi
59     #SDN_IMAGE=onos
60   elif [ "${deploy_options_array['sdn_controller']}" == 'ovn' ]; then
61     if [[ "$ha_enabled" == "True" ]]; then
62       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-ovn-ha.yaml"
63       echo "${red}OVN HA support is not not supported... exiting.${reset}"
64       exit 1
65     else
66       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-ovn.yaml"
67     fi
68     SDN_IMAGE=opendaylight
69   elif [ "${deploy_options_array['sdn_controller']}" == 'opencontrail' ]; then
70     echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
71     exit 1
72   elif [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
73     echo -e "${blue}INFO: SDN Controller disabled...will deploy nosdn scenario${reset}"
74     if [ "${deploy_options_array['vpp']}" == 'True' ]; then
75       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-vpp.yaml"
76     elif [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
77       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ovs-dpdk.yaml"
78     fi
79     SDN_IMAGE=opendaylight
80   else
81     echo "${red}Invalid sdn_controller: ${deploy_options_array['sdn_controller']}${reset}"
82     echo "${red}Valid choices are opendaylight, opendaylight-external, onos, opencontrail, False, or null${reset}"
83     exit 1
84   fi
85
86   # Enable Tacker
87   if [ "${deploy_options_array['tacker']}" == 'True' ]; then
88     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_tacker.yaml"
89   fi
90
91   # Enable Congress
92   if [ "${deploy_options_array['congress']}" == 'True' ]; then
93     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_congress.yaml"
94   fi
95
96   # Enable Real Time Kernel (kvm4nfv)
97   if [ "${deploy_options_array['rt_kvm']}" == 'True' ]; then
98     DEPLOY_OPTIONS+=" -e /home/stack/enable_rt_kvm.yaml"
99   fi
100
101   # Make sure the correct overcloud image is available
102   if [ ! -f $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 ]; then
103       echo "${red} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 is required to execute your deployment."
104       echo "Please install the opnfv-apex package to provide this overcloud image for deployment.${reset}"
105       exit 1
106   fi
107
108   echo "Copying overcloud image to Undercloud"
109   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f overcloud-full.qcow2"
110   scp ${SSH_OPTIONS[@]} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
111
112   # disable neutron openvswitch agent from starting
113   if [[ -n "${deploy_options_array['sdn_controller']}" && "${deploy_options_array['sdn_controller']}" != 'False' ]]; then
114       echo -e "${blue}INFO: Disabling neutron-openvswitch-agent from systemd${reset}"
115       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
116       LIBGUESTFS_BACKEND=direct virt-customize --run-command "rm -f /etc/systemd/system/multi-user.target.wants/neutron-openvswitch-agent.service" \
117                                                --run-command "rm -f /usr/lib/systemd/system/neutron-openvswitch-agent.service" \
118                                                -a overcloud-full.qcow2
119 EOI
120   fi
121
122   if [ "${deploy_options_array['vpn']}" == 'True' ]; then
123       echo -e "${blue}INFO: Enabling ZRPC and Quagga${reset}"
124       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
125       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y install /root/quagga/*.rpm" \
126                                                --run-command "sudo usermod -a -G quaggavt quagga" \
127                                                --run-command "sudo mkdir -p /var/run/quagga/" \
128                                                --run-command "sudo chown quagga:quagga -R /var/run/quagga/" \
129                                                --run-command "systemctl enable zrpcd" \
130                                                -a overcloud-full.qcow2
131 EOI
132   fi
133
134   # Install ovs-dpdk inside the overcloud image if it is enabled.
135   if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
136     # install dpdk packages before ovs
137     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
138
139     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
140       cat << EOF > vfio_pci.modules
141 #!/bin/bash
142 exec /sbin/modprobe vfio_pci >/dev/null 2>&1
143 EOF
144
145       cat << EOF > uio_pci_generic.modules
146 #!/bin/bash
147 exec /sbin/modprobe uio_pci_generic >/dev/null 2>&1
148 EOF
149
150       LIBGUESTFS_BACKEND=direct virt-customize --upload vfio_pci.modules:/etc/sysconfig/modules/ \
151                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
152                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
153                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
154                                                -a overcloud-full.qcow2
155
156       if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
157         sed -i "/OS::TripleO::ComputeExtraConfigPre:/c\  OS::TripleO::ComputeExtraConfigPre: ./ovs-dpdk-preconfig.yaml" network-environment.yaml
158       fi
159
160 EOI
161
162   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
163     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
164     exit 1
165   fi
166
167   if [ "$debug" == 'TRUE' ]; then
168     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
169   fi
170
171   # upgrade ovs into ovs 2.5.90 with NSH function if SFC is enabled
172   if [[ "${deploy_options_array['sfc']}" == 'True' && "${deploy_options_array['dataplane']}" == 'ovs' ]]; then
173     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
174          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_kmod_rpm_name}" \
175                                                   --run-command "yum upgrade -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_rpm_name}" \
176                                                   -a overcloud-full.qcow2
177 EOI
178   fi
179
180   # Patch neutron with using OVS external interface for router and add generic linux NS interface driver
181   if [[ "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
182     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
183       LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /usr/lib/python2.7/site-packages/ && patch -p1 < neutron-patch-NSDriver.patch" \
184                                                -a overcloud-full.qcow2
185 EOI
186
187     # Disable clustering for ODL FDIO HA scenarios
188     if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
189       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
190       LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /etc/puppet/modules/tripleo/ && patch -p1 < disable_odl_clustering.patch" \
191                                                -a overcloud-full.qcow2
192 EOI
193     fi
194
195     # Configure routing node for odl-fdio
196     if [[ "${deploy_options_array['sdn_l3']}" == 'True' ]]; then
197       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
198         sed -i "/opendaylight::vpp_routing_node:/c\    opendaylight::vpp_routing_node: ${deploy_options_array['odl_vpp_routing_node']}.${domain_name}" ${ENV_FILE}
199 EOI
200     fi
201   fi
202
203   if [ -n "${deploy_options_array['performance']}" ]; then
204     ovs_dpdk_perf_flag="False"
205     for option in "${performance_options[@]}" ; do
206       if [ "${arr[1]}" == "vpp" ]; then
207         if [ "${arr[0]}" == "Compute" ]; then
208           role='NovaCompute'
209         else
210           role=${arr[0]}
211         fi
212         if [ "${arr[2]}" == "main-core" ]; then
213           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
214             sed -i "/${role}ExtraConfig:/ c\  ${role}ExtraConfig:\n    fdio::vpp_cpu_main_core: \"'${arr[3]}'\"" ${ENV_FILE}
215 EOI
216         elif [ "${arr[2]}" == "corelist-workers" ]; then
217           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
218             sed -i "/${role}ExtraConfig:/ c\  ${role}ExtraConfig:\n    fdio::vpp_cpu_corelist_workers: \"'${arr[3]}'\"" ${ENV_FILE}
219 EOI
220         fi
221       fi
222       arr=($option)
223       # use compute's kernel settings for all nodes for now.
224       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "kernel" ]; then
225         kernel_args+=" ${arr[2]}=${arr[3]}"
226       fi
227       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "ovs" ]; then
228          eval "${arr[2]}=${arr[3]}"
229          ovs_dpdk_perf_flag="True"
230       fi
231     done
232
233     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
234       sed -i "/ComputeKernelArgs:/c\  ComputeKernelArgs: '$kernel_args'" ${ENV_FILE}
235       sed -i "$ a\resource_registry:\n  OS::TripleO::NodeUserData: first-boot.yaml" ${ENV_FILE}
236       sed -i "/NovaSchedulerDefaultFilters:/c\  NovaSchedulerDefaultFilters: 'RamFilter,ComputeFilter,AvailabilityZoneFilter,ComputeCapabilitiesFilter,ImagePropertiesFilter,NUMATopologyFilter'" ${ENV_FILE}
237 EOI
238
239     if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' && "$ovs_dpdk_perf_flag" == "True" ]]; then
240       for ovs_option in ${!ovs_option_heat_arr[@]}; do
241         if [ -n "${!ovs_option}" ]; then
242           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
243             sed -i "/${ovs_option_heat_arr[$ovs_option]}:/c\  ${ovs_option_heat_arr[$ovs_option]}: ${!ovs_option}" ${ENV_FILE}
244 EOI
245         fi
246       done
247     fi
248   fi
249
250   if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
251     if [ "${deploy_options_array['dataplane']}" == "fdio" ]; then
252       if [ "$tenant_nic_mapping_controller_members" == "$tenant_nic_mapping_compute_members" ]; then
253         echo -e "${blue}INFO: nosdn fdio deployment...installing correct vpp packages...${reset}"
254         ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
255           sed -i "/NeutronVPPAgentPhysnets:/c\  NeutronVPPAgentPhysnets: 'datacentre:${tenant_nic_mapping_controller_members}'" ${ENV_FILE}
256           LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum remove -y vpp vpp-api-python vpp-lib vpp-plugins" \
257                                                    --run-command "yum install -y /root/fdio_nosdn/*.rpm" \
258                                                    --run-command "rm -f /etc/sysctl.d/80-vpp.conf" \
259                                                    -a overcloud-full.qcow2
260 EOI
261       else
262         echo -e "${red}Compute and Controller must use the same tenant nic name, please modify network setting file.${reset}"
263         exit 1
264       fi
265     fi
266   fi
267
268   # Set ODL version accordingly
269   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && -n "${deploy_options_array['odl_version']}" ]]; then
270     case "${deploy_options_array['odl_version']}" in
271       beryllium) odl_version=''
272               ;;
273       boron)  odl_version='boron'
274               ;;
275       carbon) odl_version='master'
276               ;;
277       *) echo -e "${red}Invalid ODL version ${deploy_options_array['odl_version']}.  Please use 'carbon' or 'boron' values.${reset}"
278          exit 1
279          ;;
280     esac
281
282     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
283       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
284                                                --run-command "yum -y install /root/${odl_version}/*" \
285                                                -a overcloud-full.qcow2
286 EOI
287   fi
288
289   # Override ODL if FDIO and ODL L2
290   if [[ "${deploy_options_array['vpp']}" == 'True' && "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
291     if [ "${deploy_options_array['sdn_l3']}" == "False" ]; then
292       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
293          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
294                                                   --run-command "yum -y install /root/fdio_l2/opendaylight*.rpm" \
295                                                   -a overcloud-full.qcow2
296 EOI
297     else
298       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
299          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum remove -y vpp vpp-api-python vpp-lib vpp-plugins honeycomb" \
300                                                   --run-command "yum -y install /root/fdio_l3/*.rpm" \
301                                                   --run-command "rm -f /etc/sysctl.d/80-vpp.conf" \
302                                                   -a overcloud-full.qcow2
303 EOI
304     fi
305     if [ "${deploy_options_array['odl_vpp_netvirt']}" == "True" ]; then
306       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
307         LIBGUESTFS_BACKEND=direct virt-customize --run-command "rm -rf /opt/opendaylight/*" \
308                                                  --run-command "tar zxvf /root/odl-netvirt-vpp-distribution.tar.gz -C /opt/opendaylight/" \
309                                                  -a overcloud-full.qcow2
310 EOI
311     fi
312   fi
313
314   # check if ceph should be enabled
315   if [ "${deploy_options_array['ceph']}" == 'True' ]; then
316     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
317   fi
318
319   if [ "${deploy_options_array['sdn_controller']}" == 'ovn' ]; then
320     # The epoch in deloran's ovs is 1: and in leif's is 0:
321     # so we have to execute a downgrade instead of an update
322     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
323       LIBGUESTFS_BACKEND=direct virt-customize \
324         --run-command "cd /root/ovs27 && yum update -y *openvswitch*" \
325         --run-command "cd /root/ovs27 && yum downgrade -y *openvswitch*" \
326         -a overcloud-full.qcow2
327 EOI
328   fi
329
330   # get number of nodes available in inventory
331   num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
332   num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
333
334   # check if HA is enabled
335   if [[ "$ha_enabled" == "True" ]]; then
336     if [ "$num_control_nodes" -lt 3 ]; then
337       echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
338       exit 1
339     else
340      DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
341      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
342      echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
343     fi
344   else
345     if [ "$num_control_nodes" -lt 1 ]; then
346       echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
347       exit 1
348     fi
349   fi
350
351   if [ "$num_compute_nodes" -le 0 ]; then
352     echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
353     exit 1
354   else
355     echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
356     DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
357   fi
358
359   DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
360
361   DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
362   if [[ "$virtual" == "TRUE" ]]; then
363      DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
364   fi
365
366   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
367
368   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
369 # Create a key for use by nova for live migration
370 echo "Creating nova SSH key for nova resize support"
371 ssh-keygen -f nova_id_rsa -b 1024 -P ""
372 public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
373 sed -i "s#replace_public_key:#key: \$public_key#g" ${ENV_FILE}
374 python -c 'open("opnfv-environment-new.yaml", "w").write((open("${ENV_FILE}").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
375 mv -f opnfv-environment-new.yaml ${ENV_FILE}
376
377 source stackrc
378 set -o errexit
379 # Workaround for APEX-207 where sometimes swift proxy is down
380 if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
381   sudo systemctl restart openstack-swift-proxy
382 fi
383 echo "Uploading overcloud glance images"
384 openstack overcloud image upload
385
386 echo "Configuring undercloud and discovering nodes"
387 openstack baremetal import --json instackenv.json
388
389 if [[ -z "$virtual" ]]; then
390   openstack baremetal introspection bulk start
391   if [[ -n "$root_disk_list" ]]; then
392     openstack baremetal configure boot --root-device=${root_disk_list}
393   else
394     openstack baremetal configure boot
395   fi
396 else
397   openstack baremetal configure boot
398 fi
399
400 echo "Configuring flavors"
401 for flavor in baremetal control compute; do
402   echo -e "${blue}INFO: Updating flavor: \${flavor}${reset}"
403   if openstack flavor list | grep \${flavor}; then
404     openstack flavor delete \${flavor}
405   fi
406   openstack flavor create --id auto --ram 4096 --disk 39 --vcpus 1 \${flavor}
407   if ! openstack flavor list | grep \${flavor}; then
408     echo -e "${red}ERROR: Unable to create flavor \${flavor}${reset}"
409   fi
410 done
411 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" baremetal
412 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="control" control
413 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="compute" compute
414 echo "Configuring nameserver on ctlplane network"
415 dns_server_ext=''
416 for dns_server in ${dns_servers}; do
417   dns_server_ext="\${dns_server_ext} --dns-nameserver \${dns_server}"
418 done
419 neutron subnet-update \$(neutron subnet-list | grep -Ev "id|tenant|external|storage" | grep -v \\\\-\\\\- | awk {'print \$2'}) \${dns_server_ext}
420 sed -i '/CloudDomain:/c\  CloudDomain: '${domain_name} ${ENV_FILE}
421 echo "Executing overcloud deployment, this should run for an extended period without output."
422 sleep 60 #wait for Hypervisor stats to check-in to nova
423 # save deploy command so it can be used for debugging
424 cat > deploy_command << EOF
425 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
426 EOF
427 EOI
428
429   if [ "$interactive" == "TRUE" ]; then
430     if ! prompt_user "Overcloud Deployment"; then
431       echo -e "${blue}INFO: User requests exit${reset}"
432       exit 0
433     fi
434   fi
435
436   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
437 source stackrc
438 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
439 if ! openstack stack list | grep CREATE_COMPLETE 1>/dev/null; then
440   $(typeset -f debug_stack)
441   debug_stack
442   exit 1
443 fi
444 EOI
445
446   # Configure DPDK and restart ovs agent after bringing up br-phy
447   if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
448     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI || (echo "DPDK config failed, exiting..."; exit 1)
449 source stackrc
450 set -o errexit
451 for node in \$(nova list | grep novacompute | grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+"); do
452 echo "Checking DPDK status and bringing up br-phy on \$node"
453 ssh -T ${SSH_OPTIONS[@]} "heat-admin@\$node" <<EOF
454 set -o errexit
455 sudo dpdk-devbind -s
456 sudo ifup br-phy
457 if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
458   echo "Restarting openvswitch agent to pick up VXLAN tunneling"
459   sudo systemctl restart neutron-openvswitch-agent
460 fi
461 EOF
462 done
463 EOI
464   fi
465
466   if [ "$debug" == 'TRUE' ]; then
467       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
468 source overcloudrc
469 echo "Keystone Endpoint List:"
470 openstack endpoint list
471 echo "Keystone Service List"
472 openstack service list
473 EOI
474   fi
475 }